
#include <windows.h>
#include <string.h>
#include "exports.h"
#include "cwstart.h"


LIBMAIN

void DLL BufStripTrailingSpace(void);

void DLL
_init()
{
	/* Place all 'LibExport' calls here.
	 */
	LibExport( "int StripSpaceHandler long long" );
	LibExport( "void BufStripTrailingSpace" );

	/* register the save buffer event to be triggered when
	 * a file is written to disk.
	 */
	EventRegister( EVENT_SAVE_BUFFER, EVENT_NORMAL, "StripSpaceHandler" );
}


/*
 * strip_trailing()
 *
 * This function is an event handler which is invoked when a file is about to
 * be written to disk.  At this point we have the opportunity to change the
 * buffer in any way we would like.  In this case, we strip whitespace from
 * the ends of lines.
 */

int DLL
StripSpaceHandler( long evtnum, long datap )
{
	BufStripTrailingSpace();
	return 0;   /* return 0 to allow the file to be saved, !0 is an error */
}

void DLL
BufStripTrailingSpace(void)
{
	MarkSavePos();
	SrchTranslate("[ \t]+$", "",
		SEARCH_GLOBAL | SEARCH_MAXIMAL | SEARCH_REGEX | SEARCH_WRAP, 0);
	MarkRestorePos();
}

